#!/bin/bash

# Build 48k speech files

# $Id: 8k-mIRSS.sh,v 1.1 2018/11/22 22:32:01 pkabal Exp $

FileList="FileList.txt"
TextFile="HarvardList.dat"

DirI="../48k/"
DirO="../8k-mIRSS/"
DBID="8k-mIRSS"

LPx6="../Filters/STL_mIRSS_LPx6_FIR_48k.cof"

Proc="Filtered and subsampled 6:1"
Filt="ITU-T G.191 Software Tools Library
Linear phase FIR filter (2001 coefficients at 48 kHz)
(1) modified IRS (send) (495 coefficients at 16 kHz), STL_mIRSS_FIR_16k.cof\\
(2) lowpass (168 coefficients at 48 kHz), STL_LPx3_FIR.cof
(3) lowpass (118 coefficients at 16 kHz), STL_LPx2_FIR.cof"

#==========
function ProcFile ()
{
  local File
  local FileI
  local FileO
  local Dir
  local FileDate
  local InfoDate
  local InfoProc
  local InfoFile

  File=$1
  FileI="${DirI}${File}"
  FileO="${DirO}${File}"

# Create the subdirectory for the output file (example "../8k-mIRSS/CA")
# See linuxgazette.net/18/bash.html
  Dir=${FileO%/*}     # Erase the shortest match to /* from the end
  mkdir -p $Dir

# Generate the info strings
  GenInfoString "$FileI" "$TextFile" "$DBID"

# Date / processing / filtering info strings
  FileDate=`date -u '+%Y-%m-%d %H:%M:%S UTC'`
  InfoDate="date: $FileDate"
  InfoProc="processing: $Proc"
  InfoFilt="filter: $Filt"

# Filter: 2001 taps, symmetric FIR, delay 1000 samples at 48 kHz
  FiltAudio -f "$LPx6" -i 1/6 "$FileI" \
 -I "" -I "$InfoDate" -I "$InfoTitle" -I "$InfoDB" -I "$InfoID" \
 -I "$InfoSpkr" -I "$InfoText" -I "$InfoRecCond" \
 -I "$InfoProc" -I "$InfoFilt" \
 -D integer16 "$FileO"

# Print file information
  echo ""
  InfoAudio -i5 "$FileO"
}

# Load function
. GenInfo.sh

#===========
# Loop over files
exec < $FileList

while read File
do
  ProcFile $File
done
